#version 150

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform vec4 FogColor;

in vec2 texCoord0;
in float zPos;

out vec4 fragColor;

void main() {
    vec4 color = texture(Sampler0, texCoord0);
    if (color.a == 0.0) {
        discard;
    }
    fragColor = color * ColorModulator;
    if (zPos == 0.0 || zPos == 100.0) {
        // Brighten up if too dark
        float brightness = (FogColor.r + FogColor.g + FogColor.b) / 3.0;
        float brightnessMultiplier = 1.0;
        if (brightness < 0.25) {
            brightnessMultiplier = (1.0 - brightness) * 10.0;
        }

        // Grayscale then tint inventory
        fragColor.rgb = vec3((fragColor.r + fragColor.g + fragColor.b) / 3.0) * FogColor.rgb;

        // Apply brightness multiplier
        fragColor.rgb *= brightnessMultiplier;

        // Blindness & darkness status effects change fog to pitch black, which in turn makes the UI pitch black. In this case, set a preset so you can see shit
        if (FogColor.rgb == vec3(0.0)) {
            fragColor = color * ColorModulator;
        }
    }
}